Type block
	Field modell
	Field typ
	Field gruppe
	Field eig
	Field aktiv
End Type

Type Karte
	Field modell,b.block
	Field nr,ausg
	Field name$
	Field bild
	Field geschafft
End Type

Function LadeKarte(name$,objekt)
	k.Karte=Object.Karte(objekt)
	
	If FileType("Karten\"+name$)=1 Then
		planeY=-150
		
		k\modell=LoadAnimMesh("Karten\"+name$)
		;ScaleEntity k\modell,0.05,0.05,0.05
		For t_i=1 To CountChildren(k\modell)
			t_c=GetChild(k\modell,t_i)
			k\b.block=New block
			k\b\modell=t_c
			ScaleMesh k\b\modell,0.05,0.05,0.05
			EntityType k\b\modell,10
			EntityPickMode k\b\modell,2
			MittelpunktModell(k\b\modell)
			;EntityAlpha b\modell,0.6
			
			
			If Left(EntityName(t_c),5)="block" Then
				
				u1=Instr(EntityName(t_c),"_")
				If u1=0 Then u1=Len(EntityName(t_c))+1
				u2=Instr(EntityName(t_c),"_",u1+1)
				If u2=0 Then u2=Len(EntityName(t_c))+1
				
				k\b\typ=Int(Mid(EntityName(t_c),6,u1-6))
				k\b\gruppe=Int(Mid(EntityName(t_c),u1+1,u2-u1))
				k\b\eig=Int(Mid(EntityName(t_c),u2+1,-1))
				
				If k\b\typ<10 Then EntityColor k\b\modell,Rand(0,255),Rand(0,255),Rand(0,255)
			EndIf
			
			If EntityName(t_c)="planey" Then planeY=EntityY(k\b\modell):HideEntity t_c
		Next
		;Stop
		;FreeEntity k\modell
	Else
		Return 0
	EndIf
End Function

Function MittelpunktModell(modell)
	Local dsx#,dsy#,dsz#
	
	For t_s=1 To CountSurfaces(modell)
		t_surface=GetSurface(modell,t_s)
		For t_v=0 To CountVertices(t_surface)-1
			dsx#=dsx#+VertexX#(t_surface,t_v)
			dsy#=dsy#+VertexY#(t_surface,t_v)
			dsz#=dsz#+VertexZ#(t_surface,t_v)
		Next
		dsx#=dsx#/(CountVertices(t_surface))
		dsy#=dsy#/(CountVertices(t_surface))
		dsz#=dsz#/(CountVertices(t_surface))
	Next
	
	For t_s=1 To CountSurfaces(modell)
		t_surface=GetSurface(modell,t_s)
		For t_v=0 To CountVertices(t_surface)-1
			VertexCoords t_surface,t_v,VertexX#(t_surface,t_v)-dsx#,VertexY#(t_surface,t_v)-dsy#,VertexZ#(t_surface,t_v)-dsz#
		Next
	Next
	
	;amodell=CreateSphere()
	;ScaleEntity amodell,1,1,1
	;,dsx#-VertexX(t_surface,t_v),dsy#-VertexY(t_surface,t_v),dsz#-VertexZ(t_surface,t_v)
	;,VertexX(t_surface,t_v)-dsx#,VertexY(t_surface,t_v)-dsy#,VertexZ(t_surface,t_v)-dsz#
	PositionEntity modell,EntityX#(modell)+dsx#,EntityY#(modell)+dsy#,EntityZ#(modell)+dsz#
	
	Return modell
End Function

Function UBlock()
	For b.block=Each block
		If EntityCollided(typ,10)=b\modell Then
			For t_c=1 To CountCollisions(typ)
				If CollisionY(typ,t_c)<EntityY(typ) Then EntityParent typ,b\modell:Exit
			Next
		Else
			EntityParent typ,0
		EndIf
		Select b\typ
			Case 1
				
			Case 2
				If b\aktiv=1 Then MoveEntity b\modell,0,-0.3,0;0.2
				If EntityCollided(typ,10)=b\modell Then ;EntityY(typ)<=EntityY(b\modell)+MeshHeight(b\modell)/2+16 And EntityDistance(typ,b\modell)<60 Then
					For bb.block=Each block
						If bb\gruppe=b\gruppe Then bb\aktiv=1
					Next
				EndIf
			Case 3
				If b\aktiv Then MoveEntity b\modell,0,0,-0.2
			Case 4
				TurnEntity b\modell,0,0.2,0
				;If EntityCollided(typ,10)=b\modell Or EntityCollided(b\modell,1)=typ Then End
			Case 5
				If b\aktiv=1 Then MoveEntity b\modell,-1.5,0,0;0.2
				If EntityCollided(typ,10)=b\modell Then ;EntityY(typ)<=EntityY(b\modell)+MeshHeight(b\modell)/2+16 And EntityDistance(typ,b\modell)<60 Then
					For bb.block=Each block
						If bb\gruppe=b\gruppe Then bb\aktiv=1
					Next
				EndIf
			Case 6
				If b\aktiv=1 Then MoveEntity b\modell,-1.5,0,0;0.2
				If EntityCollided(typ,10)=b\modell Then ;EntityY(typ)<=EntityY(b\modell)+MeshHeight(b\modell)/2+16 And EntityDistance(typ,b\modell)<60 Then
					For bb.block=Each block
						If bb\gruppe=b\gruppe Then bb\aktiv=1
					Next
				EndIf
			Case 3
			Case 10
				If EntityCollided(typ,10)=b\modell Then Cls:Locate 500,290:FlushKeys():Print "Verloren!":WaitKey():Menu():Exit
				
			Case 11
				If EntityCollided(typ,10)=b\modell Then Cls:Locate 500,290:FlushKeys():Print "Gewonnen!":WaitKey():Menu():Exit
				
		End Select
	Next
End Function

Function Steuerung()
	sprungf#=0.8
	gesh#=1.6
	TurnEntity kamera,MouseYSpeed()/(2.1),0,0
	TurnEntity typ,0,-MouseXSpeed()/(2.1),0
	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
	
	
	If KeyDown(17) Then MoveEntity typ,0,0,gesh#:Goto a
	If KeyDown(32) Then MoveEntity typ,(gesh#)*3/4,0,0:Goto a
	If KeyDown(30) Then MoveEntity typ,(-gesh#)/1.7,0,0:Goto a
	If KeyDown(31) Then MoveEntity typ,0,0,(-gesh#)*3/4:Goto a
	.a
	
	If EntityDistance (typ,sprungk)<20 Then 
		colli=1
	Else 
		colli=0
	EndIf
	
	Auf(sprungk,typ)
	MoveEntity sprungk,0,30,0
	TranslateEntity sprungk,0,-60,0
	
	If KeyDown(57) And sprungz<10 Then TranslateEntity typ,0,sprungf#*(-(sprungz/3)+6),0:sprungz=sprungz+1
	If  KeyDown(57)=0  And colli<>0 Then sprungz=-0
	If KeyDown(57)=0  And colli=0 Then sprungz=90
	
	If colli=1 Then fallz=20
	If colli=0 Then fallz=fallz+1
	If fallz>500 Then fallz=0
	
	MoveEntity typ,0,-fallz/20.0,0
End Function

Function Auf(Aufquelle,Aufziel,Aufzziel=0,AufWahl=0,AufHide=1)
	If AufHide=1 Then HideEntity Aufquelle
	If Aufzziel=0 Then Aufzziel=Aufziel
	Select AufWahl
		Case 1
			PositionEntity Aufquelle,EntityX#(Aufziel,1),EntityY#(Aufziel,1),EntityZ#(Aufziel,1),1
		Case 2
			RotateEntity Aufquelle,EntityPitch(Aufzziel),EntityYaw(Aufziel),EntityRoll(Aufziel),1
		Default 
			RotateEntity Aufquelle,EntityPitch(Aufzziel),EntityYaw(Aufziel),EntityRoll(Aufziel),1
			PositionEntity Aufquelle,EntityX#(Aufziel,1),EntityY#(Aufziel,1),EntityZ#(Aufziel,1),1
	End Select 
	ShowEntity Aufquelle
End Function

Function UTeleport()
	If mhit1 Then
		pick=CameraPick(kamera,MouseX(),MouseY())
		For b.block=Each block
			If b\modell=pick And b\typ<>0 And b\typ<>3 And b\typ<10 And b\typ<>5 Then
				If bausg=0 Then
					bausg=b\modell
					EntityFX bausg,1
				Else
					If bausg<>b\modell Then
					Auf(bausg,b\modell)
					
					triangle=PickedTriangle()
					surface=PickedSurface()
					v0=TriangleVertex(surface,triangle,0)
					v1=TriangleVertex(surface,triangle,1)
					v2=TriangleVertex(surface,triangle,2)
					
					avx=Abs(VertexX(surface,v0)-VertexX(surface,v1))+Abs(VertexX(surface,v0)-VertexX(surface,v2))
					avy=Abs(VertexY(surface,v0)-VertexY(surface,v1))+Abs(VertexY(surface,v0)-VertexY(surface,v2))
					avz=Abs(VertexZ(surface,v0)-VertexZ(surface,v1))+Abs(VertexZ(surface,v0)-VertexZ(surface,v2))
					
					
					If avx<avy And avx<avz Then
						MoveEntity bausg,(MeshWidth#(bausg)/2.0+MeshWidth#(b\modell)/2.0) * (1-2*(EntityX(kamera,1)<VertexX(surface,v0)+EntityX(b\modell))),0,0
					ElseIf avy<avx And avy<avz Then
						MoveEntity bausg,0,(MeshHeight#(bausg)/2.0+MeshHeight#(b\modell)/2.0) * (1-2*(EntityY(kamera,1)<VertexY(surface,v0)+EntityY(b\modell))),0
					ElseIf avz<avx And avz<avy Then
						MoveEntity bausg,0,0,(MeshDepth#(bausg)/2.0+MeshDepth#(b\modell)/2.0) * (1-2*(EntityZ(kamera,1)<VertexZ(surface,v0)+EntityZ(b\modell)))
					EndIf
				EndIf
				
					EntityFX bausg,0
					bausg=0
				EndIf
			EndIf
		Next
			
	EndIf
	
	
	If mhit2 Then
		For b.block=Each block
			EntityFX b\modell,0
		Next
		bausg=0
	EndIf
	;doof
	;und damlich
End Function

Function LadeKarten()
	dir=ReadDir("Karten")
	Repeat
		datei$=NextFile(dir)
		If datei$="" Then
			Exit
		ElseIf Left(datei$,5)="karte" And Int(Mid(datei$,6,Instr(datei$,".")-6))>0 Then
			k.Karte=New Karte
			k\nr=Int(Mid(datei$,6,Instr(datei$,".")-6))
			k\name$=datei$
			k\bild=LoadImage("Karten\Bilder\"+Left(datei$,Len(datei$)-4)+".jpg")
		EndIf			
	Forever
End Function 

Function Menu()
	SetFont font
	FlushKeys()
	For k.Karte=Each Karte
		k\ausg=0
	Next
	Repeat
		For k.Karte=Each Karte
			If MouseY()>=k\nr*120-70 And MouseY()<k\nr*120-70+96 And MouseX()>49 And MouseX()<49+96 And MouseDown(1) Then 
				For kk.Karte=Each Karte
					kk\ausg=0
				Next
				k\ausg=1
			EndIf
			
			If k\ausg And KeyDown(28) Then
				For kk.Karte=Each Karte
					If kk\modell<>0 Then
						For kk\b.block=Each block
							If kk\b\modell<>0 Then
								
								HideEntity kk\b\modell
								FreeEntity kk\b\modell
							EndIf
							Delete kk\b.block
						Next
						
						For b.block=Each block
							If b\modell<>0 Then
								FreeEntity b\modell
							EndIf
						Next
						Delete Each block
						;If kk\modell<>0 Then HideEntity kk\modell:FreeEntity kk\modell
					EndIf
				Next
				
				LadeKarte(k\name$,Handle(k)):raus=1:Exit
			EndIf
		Next
		If raus Then Exit
	Cls
	For k.Karte=Each Karte
		Color 255,0,0
		If k\ausg Then 
			Rect 49,k\nr*120-71,98,98,0
			Rect 48,k\nr*120-72,100,100,0
		EndIf
		Color 255,255,255
		;Text 10,k\nr*20,k\name$
		DrawImage k\bild,50,k\nr*120-70
	Next
	
	DrawImage logo,380,340
	
	Text 300,100,"Klicke eins der Bilder an, um die entsprechende Karte auszuwhlen."
	Text 300,120,"Drcke Enter, um loszuspielen. Viel Spa!"
	
	Text 300,160,"Gesteuert wird mit WASD, Leertaste sowie der Maus zum umschauen."
	Text 300,180,"Viele der Blcke im Spiel knnen mit einem linken Mausklick ausgewhlt"
	Text 300,200,"werden. Ein weiterer Mausklick teleportiert die Blcke zum jetzt ange- "
	Text 300,220,"klicktem Block."
	Text 300,240,"Rote, halbdurchsichtige Gebilde sowie der rote Sumpf sind hochgefhrlich."
	Text 300,260,"Die blauen, halbdurchsichtigen Pyramiden sind das Ziel, das zu erreichen"
	Text 300,280,"ist."
	
	Flip
	WaitTimer(timer)
	If KeyDown(1) Then End
Forever
PositionEntity plane,0,planeY-14,0
SetFont font2

HideEntity typ
PositionEntity typ,0,0,0
ShowEntity typ
End Function 

Global sprungz,fallz,mhit1,mhit2,bausg,wframe#,planeY

AppTitle "J'R Blockk"
Graphics3D 900,700,0,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()

Global font=LoadFont("Arial",20)

Global font2=LoadFont("Arial",50)
SetFont font2


Global logo=LoadImage("Bilder\Logo.png")
MaskImage logo,77,77,77

ClsColor 60,0,60

Global timer=CreateTimer(40)

Global typ=CreatePivot()
EntityRadius typ,6,15
EntityType typ,1
Global sprungk=CreateSphere()
EntityAlpha sprungk,0
EntityType sprungk,2

Global kamera=CreateCamera(typ)
CameraFogColor kamera,100,200,200
CameraFogRange kamera,250,400
CameraFogMode kamera,1
MoveEntity kamera,0,10,0
CameraClsColor kamera,100,200,255
;LadeKarte("karte5")

Global plane=CreatePlane()
EntityColor plane,255,100,100
EntityAlpha plane,0.7
wtextur=LoadAnimTexture("Bilder\animwasser.bmp",0,128,128,0,16)
ScaleTexture wtextur,1000,1000
EntityFX plane,1

AmbientLight 150,150,150
EntityFX plane,1

licht=CreateLight()
MoveEntity licht,0,100,0
himmel=CreateSphere(8,typ)
ScaleEntity himmel,1000,1000,1000
FlipMesh himmel


Collisions 1,10,2,3
Collisions 2,10,2,1
Collisions 10,1,2,1

LadeKarten()
Menu()

While Not KeyDown(1)
	mhit1=MouseHit(1)
	mhit2=MouseHit(2)
	
	wframe=wframe+0.5
;	wframe=wframe*wframe<16
	If wframe>15 Then wframe=0.5
	EntityTexture plane,wtextur,wframe
	
	UBlock()
	UTeleport()
	Steuerung()
	
	If EntityY(typ)<planeY Then Cls:Locate 500,290:FlushKeys():Print "Verloren!":WaitKey():Menu()
	
	WaitTimer(timer)
	
	UpdateWorld
	RenderWorld
	
	Flip
Wend
FlushKeys()
Delay 200
Menu()
End
;~IDEal Editor Parameters:
;~F#0#8#10#3A#59#8A#AD#BC#EF#FE
;~C#Blitz3D