Import bah.freeimage
SuperStrict


AppTitle = "PocketLight Mapeditor"

Local Map:Byte[,]
Local width:Int
Local height:Int
Local name:String = Input("levelname: ")
If FileType("level/"+name)
	Local strm:TStream = ReadFile("level/"+name)
	width = strm.ReadInt()
	height = strm.ReadInt()
	map = New Byte[width, height]
	For Local x:Int = 0 Until width
		For Local y:Int = 0 Until height
			map[x,y] = strm.ReadByte()
		Next
	Next
	Rem
	Local Objs:Int = strm.ReadInt()
	For Local i:Int = 0 Until objs
		Local obj:Tobject = New Tobject
		obj.typ = strm.ReadInt()
		obj.x = strm.ReadInt()
		obj.y = strm.ReadInt()
		
		
		strm.WriteInt obj.typ
		strm.WriteInt obj.x
		strm.WriteInt obj.y
		
		strm.WriteInt obj.data.length
		For Local i:Int = 0 Until obj.data.length
			strm.WriteInt obj.data[i]
		Next
		
	Next
	EndRem
Else
	width = Int(Input( "Bitte geben Sie die Mapbreite an: "))
	height = Int(Input("Bitt geben Sie die Maphoehe an: "))
	Map = New Byte[width, height]
EndIf

Local ScrollX:Int, ScrollY:Int

Graphics 800,600
Local Timer:TTimer = CreateTimer(40)
Local SelectTile:Int = 1
Local objects:TList = New TList
Type TObject
	Field x:Int, Y:Int
	Field typ:Int
	Field data:Int[]
EndType
Repeat
	If MouseHit(2) SelectTile = (SelectTile + 1) Mod 3
	
	ScrollX :+ (KeyDown(KEY_LEFT) - KeyDown(KEY_RIGHT))*4
	ScrollY :+ (KeyDown(KEY_UP) - KeyDown(KEY_DOWN))*4
	Local tilex:Int, tiley:Int
	tilex = Floor((MouseX()-ScrollX)/32.0)*32
	tiley = Floor((MouseY()-scrolly)/32.0)*32
	
	SetOrigin ScrollX, ScrollY
	Select SelectTile
		Case 0
			SetColor 0,0,0
		Case 1
			SetColor 255,0,0
		Case 2
			SetColor 0,0,255
	EndSelect
	
	DrawRect tilex,tiley,32,32
	SetColor 255,255,255
	If MouseDown(1) And tilex/32>=0 And tiley/32>=0 And tilex/32<width And tiley/32<height
		Map[tilex/32,tiley/32] = SelectTile
	EndIf
	For Local x:Int = 0 Until width
		DrawLine x*32,0,x*32,height*32
	Next
	For Local y:Int = 0 Until height
		DrawLine 0,y*32,width*32,y*32
	Next
	DrawLine width*32,0,width*32,height*32
	DrawLine 0,height*32,width*32,height*32
	For Local x:Int = 0 Until width
		For Local y:Int = 0 Until height
			If Map[x,y]
				If Map[x,y] = 1
					SetColor 255,0,0
				ElseIf Map[x,y] = 2
					SetColor 0,0,255
				EndIf
				DrawRect x*32,y*32,32,32
			EndIf
		Next
	Next
	SetColor 0,255,0
	For Local o:Tobject=EachIn objects
		DrawOval o.x-8,o.y-8,16,16
	Next
	SetColor 255,255,255
	SetOrigin 0,0
	
	DrawText "Linke Maustaste zum setzen Rechte zum zappen S zum Speichern",10,10
	
	If KeyHit(KEY_S)
		'speichern
		Local strm:TStream = WriteFile("level/"+name)
		strm.WriteInt width
		strm.WriteInt height
		For Local x:Int=0 Until width
			For Local y:Int=0 Until height
				strm.WriteByte map[x,y]
			Next
		Next
		Rem
		strm.WriteInt objects.count()
		For Local obj:Tobject=EachIn objects
			strm.WriteInt obj.typ
			strm.WriteInt obj.x
			strm.WriteInt obj.y
			strm.WriteInt obj.data.length
			For Local i:Int = 0 Until obj.data.length
				strm.WriteInt obj.data[i]
			Next
		Next
		EndRem
		strm.close
		Print "Gespeichert"
	EndIf
	If KeyHit(KEY_SPACE)
		Print "0: Taschenlampe, 1: Portal, 2: Spiegel"
		Local o:TObject = New Tobject
		o.typ = Int(Input("Typ: "))
		o.data = New Int[Int(Input("Daten?: "))]
		For Local i:Int = 0 Until o.data.length
			o.data[i] = Int(Input("Data "+i+": "))
		Next
		
		o.x = tilex
		o.y = tiley
		objects.addlast o
	EndIf
	If KeyHit(KEY_D)
		For Local o:tobject=EachIn objects
			If getdistance(o.x,o.y,tilex,tiley)<18
				objects.remove o
			EndIf
		Next
	EndIf

	Flip 0
	Cls
	WaitTimer Timer
Until KeyHit(KEY_ESCAPE) Or AppTerminate()

Function getdistance:Float(x1:Float,y1:Float,x2:Float,y2:Float)
	Return Sqr((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2))
End Function

